<?php

namespace app\admin\controller\mall;

use Throwable;
use app\common\controller\Backend;

/**
 * 兑换订单
 */
class RedemptionOrder extends Backend
{
    /**
     * MallRedemptionOrder模型对象
     * @var object|null
     * @phpstan-var \app\common\model\MallRedemptionOrder|null
     */
    protected ?object $model = null;

    protected array|string $preExcludeFields = ['id', 'create_time', 'update_time'];

    protected array $withJoinTable = ['playxUserAsset', 'mallItem'];

    protected string|array $quickSearchField = ['id'];

    public function initialize(): void
    {
        parent::initialize();
        $this->model = new \app\common\model\MallRedemptionOrder();
    }

    /**
     * 查看
     * @throws Throwable
     */
    public function index(\Webman\Http\Request $request): \support\Response
    {
        $response = $this->initializeBackend($request);
        if ($response !== null) {
            return $response;
        }

        if ($request->get('select') || $request->post('select')) {
            $this->_select();
            return $this->success();
        }

        /**
         * 1. withJoin 不可使用 alias 方法设置表别名，别名将自动使用关联模型名称（小写下划线命名规则）
         * 2. 以下的别名设置了主表别名，同时便于拼接查询参数等
         * 3. paginate 数据集可使用链式操作 each(function($item, $key) {}) 遍历处理
         */
        list($where, $alias, $limit, $order) = $this->queryBuilder();
        $res = $this->model
            ->with(['playxUserAsset' => function ($query) {
                $query->field('id,username');
            }])
            ->visible(['playxUserAsset' => ['username'], 'mallItem' => ['title']])
            ->alias($alias)
            ->where($where)
            ->order($order)
            ->paginate($limit);

        return $this->success('', [
            'list'   => $res->items(),
            'total'  => $res->total(),
            'remark' => get_route_remark(),
        ]);
    }

    /**
     * 若需重写查看、编辑、删除等方法，请复制 @see \app\admin\library\traits\Backend 中对应的方法至此进行重写
     */
}